/*

޳   Program  aquery.prg
޳            demonstration program for a clipper 5.0
޳            filter/query/condition builder
޳           

޳   Compile  Clipper aquery /N /Q /A
޳      Link  rtlink fi aquery,\fu\funstack ;
޳                   lib \fu\funcky50,\fu\funcky15 /pll:base50
޳           
޳            load size = 259k
޳            exe size  = 64512
޳           
޳            NOTE: this might not be the most efficient, but it works
޳           

޳    Author  Wayne Byerly 76557,1052
޳ Copyright  1991, all rights reserved.
޳           

޳  Internal  Main()         main function for this demo
޳ Functions  VertMenu()     menuing routine
޳            Aread()        set cursor on; read; set cursor off
޳            Center()       centers text on a line
޳            Window()       draws boxes on the screen
޳            Filter()       query/filter/condition function
޳            SayVerbiage()  displays filter as its being built
޳            FieldSelect()  select a field
޳            ClearFrom()    clears screen FROM a line
޳            ImmedError()   display error wait 3 seconds
޳            

޳    Funcky  M_APROMPT()
޳ Functions  M_CSRON()
޳      Used  M_CSROFF()
޳            M_RESET()
޳            BLINKBIT()
޳            CSRON()
޳            CSROFF()
޳            SETATTRIB()
޳            M_DATA()
޳            WAITKEY()
޳            SETATTR()
޳            PRINT()
޳            MX_CHOICE()
޳            BOX()
޳            

޳  Comments  these routines follow "freeware" conventions.
޳            feel free to use these routines however you see fit.
޳            you may not however charge anyone for them.
޳            
޳            use these routines at your own risk as they are not
޳            guaranteed in any way shape or form.
޳            
޳            this demo was extracted from an old system written long
޳            ago and quickly translated to clipper 5.0. maybe it works
޳            great and maybe it doesn't. questions and comments 
޳            are welcome. abuse and jokes strictly ignored.
޳            
޳            capitalization other programming conventions used are
޳            the ones _I_ like. no justifications or apologies.
޳            
޳            


*/


#include "inkey.ch"
#include "setcurs.ch"

#define TRUE            .T.
#define FALSE           .F.

#define HEADERSEP		    ""
#define COLUMNSEP		    "  "

#define SHADOWTYPE      3
#define SHADOWCOLOR     7

#define FTYPE           1
#define LENGTH          2

#command  MOUSE ON  =>  M_CSRON()
#command  MOUSE OFF =>  M_CSROFF()

// funcky colors
static c_DeskTop  := 143     && background outside of windows
static c_Message  := 139     && messages
static c_WinTxt   :=  31     && window text
static c_HotKey   :=  30     && hot key color
static c_WinBox   :=  16
static aField     := {} 

function Main()
  local nKount := 0
  //
  private cCondition := ""
  //
  // environment
  M_RESET()                  && funcky
  BLINKBIT( FALSE)           && funcky
  CSRON()                    && funcky
  CSROFF()                   && funcky
  MOUSE ON                   && funcky
  MOUSE OFF                  && funcky
  SETATTRIB( "t", c_HotKey)
  shadowtype( 3, 8, chr(255)+ chr(255)+ chr(255))
  M_DATA( 3, 1)              && return if they click outside the window
  M_DATA( 8, 1)              && top virtual row
  M_DATA( 10, LASTROW()- 2)  && bottom virtual row account for shadow
  M_DATA( 22, 1)             && autosave on exit
  M_DATA( 29, 1)
  set scoreboard off
  //
  use \CFM\MASTER new
  copy structure to TEMP extended
  use TEMP new
  do while ! eof()
    aadd( aField, {TEMP->Field_type, TEMP->Field_len } )
    skip
  enddo
  use
  erase TEMP.DBF
  select MASTER
  //
  ClearFrom( 0)
  cCondition := Filter()
  //
  if ! empty( cCondition)
    Center( maxrow(), "Counting...")
    count for &cCondition to nKount
    Center( maxrow(), ltrim( str( nKount))+ " records match. Press any key")
    inkey(0)
  else
    Center( maxrow(), "No filter/query/condition selected. Press any key.")
    inkey(0)
  endif
return NIL
//
// end aquery



function VertMenu( aMenuArray, nTop, nLeft, cHead, cFoot, lErase)
  local n                    && for loop counter
  local nChoice              && currently selected menu option
  local aMenuRows := {}      && menu display rows
  local aMenuCols := {}      && menu display cols
  local sScreen              && saved screen
  local nWidth               && prompt width
  local nElements            && number of elements in the menu array
  //
  // set optional parameters if necessary
  cHead     := iif( cHead == NIL, "", cHead)
  cFoot     := iif( cFoot == NIL, "", cFoot)
  lErase    := iif( valtype( lErase) == "U", FALSE, lErase)
  //
  nElements := len( aMenuArray)
  nWidth    := len( aMenuArray[1])- 4
  //
  asize( aMenuRows, nElements)
  asize( aMenuCols, nElements)
  //
  // if "erase" this menu when done
  if lErase
    sScreen = savescreen( nTop-1, nLeft- 2, nTop+ nElements+ 2,           ;
    nLeft+ nWidth+ 6)
  endif
  //
  Window( nTop- 1, nLeft- 2, nTop+ nElements, nLeft+                      ;
  nWidth+ 1, cHead, cFoot)
  for n := 1 TO nElements
    aMenuRows[n] := nTop+ n- 1
    aMenuCols[n] := nLeft
  next
  //
  MOUSE ON
  nChoice := M_APROMPT( .F., 1, aMenuRows, aMenuCols, aMenuArray, c_WinTxt)
  MOUSE OFF
  //
  if lErase
    restscreen( nTop-1, nLeft- 2, nTop+ nElements+ 2, nLeft+              ;
    nWidth+ 6, sScreen)
  endif
return (nChoice)
//
// end vertmenu



function Filter()
  //
  local aMainMenu      := {                                               ;
  "^tR^night Parenthesis       ",                                         ;
  "^tL^neft Parenthesis        ",                                         ;
  "^tF^nield                   ",                                         ;
  "^tC^nonnector               ",                                         ;
  "^tN^no condition            ",                                         ;
  "^tD^none                    ",                                         ;
  "^tA^nbandon condition       ",                                         ;
  "^tS^ntart Over              ",                                         ;
  "^tV^niew More of condition  "}  
  local cTempFilter    := ""            && temporary storage for filter
  local cCondition     := ""            && filter being built
  local nRPCount       := 0             && counter for right parenthesis
  local nLPCount       := 0             && counter for left parenthesis
  local cValidChoices  := ""            && char string of valid actions
  local nChoice        := 0             && MENU TO action
  local nLastChoice    := 0             && last action
  local cErrorMsg      := ""            && error messages
  local lDone          := FALSE         && are u dun yet?
  local cFieldName     := ""            && field name
  local nFieldNumber   := 0             && field number
  local nOperator      := 0             && nOperatorator
  local nConnector     := 0             && nConnector
  local lResponse      := FALSE         && user lResponseonse
  local cClause        := ""            && get cTemp pict cClause
  local cMsg           := ""            && message holder
  local xTemp                           && temporary var could be any type
  local nTheFile       := select()
  //
  nFcount := fcount()
  ClearFrom( maxrow())
  Window( 16, 22, 21, 76, " THE CONDITION BEING BUILT ", "")
  do while ! lDone
    SayVerbiage( cCondition)
    do case
      case nLastChoice == 0            && just entered this routine
        cValidChoices  := " 2| 3| 5| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are '(', field, remove, abandon, restart, or view"
      case nLastChoice == 1            && right paren
        cValidChoices  := " 1| 4| 6| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are ')', Connector, Done, abandon, restart, or view"
      case nLastChoice == 2            && left paren
        cValidChoices  := " 2| 3| 4| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are '('  field, Connector, abandon, restart, or view"
      case nLastChoice == 3            && field
        cValidChoices  := " 1| 4| 6| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are ')'  Connector, Done,  abandon, restart, or view"
      case nLastChoice == 4            && Connector
        cValidChoices  := " 2| 3| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are '(', field,  abandon, restart, or view"
      case nLastChoice == 8            && start over
        cValidChoices  := " 1| 2| 3| 4| 5| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "You cannot specify 'Done' at this time"
      case nLastChoice == 11           && retrieve
        cValidChoices  := " 6| 7| 8| 9"
        cErrorMsg      :=                                                 ;
          "Valid options are 'Done, abandon, start over, or view"
    endcase
    //
    // MAIN MENU
    //
    Center( maxrow(), "Select an ACTION by pressing the LETTER or by Cu"+ ;
      "rsor Movement & <Return>")
    nChoice := 999
    do while ! str( nChoice, 2) $ cValidChoices
      ClearFrom( maxrow())
      nChoice = VertMenu( aMainMenu, 04, 24, " ACTIONS ", "", TRUE)
      //
      if nChoice == 0                  && esc?
        nChoice  := 7
      endif
      ClearFrom( maxrow())
      if ! str( nChoice, 1) $ cValidChoices
        tone( 4000, 1)
        Center( maxrow(), cErrorMsg)
        WAITKEY( 3)
        ClearFrom( maxrow())
      else
        exit
      endif
    enddo
    //
    //
    nLastChoice  := nChoice
    ClearFrom( maxrow())
    do case
      case nChoice == 3                && field
        a           := FieldSelect()
        if a == 0
          exit
        endif
        cFieldName   := field( a)
        //
        do case
          case aField[ a, FTYPE] == "C" .and. aField[ a, LENGTH] > 15 .or.;
              aField[ a, FTYPE] == "M"
            cClause  := "!!!!!!!!!!!!!!!"
            xTemp    := space(15)
            aMenu    := {                                                 ;
              "^tC^nontains        ",                                     ;
              "^tD^noesn't Contain "}
          case aField[ a, FTYPE] == "C" .and. aField[ a, LENGTH] <= 15
            xTemp    := replicate( " ", aField[ a, LENGTH])
            cClause  := replicate( "!", aField[ a, LENGTH])
            aMenu    := {                                                 ;
              "^tE^nqual to        ",                                     ;
              "^tN^not Equal to    ",                                     ;
              "^tL^ness Than or Eq.",                                     ;
              "^tM^nore Than or Eq."}
          case aField[ a, FTYPE] == "N"
            cClause  := ""
            xTemp    := 0
            aMenu    := {                                                 ;
              "^tE^nqual to        ",                                     ;
              "^tN^not Equal to    ",                                     ;
              "^tL^ness Than or Eq.",                                     ;
              "^tM^nore Than or Eq."}
          case aField[ a, FTYPE] == "D"
            cClause  := ""
            xTemp    := ctod( "")
            aMenu    := {                                                 ;
              "^tL^ness Than or Eq.",                                     ;
              "^tE^nqual to        ",                                     ;
              "^tM^nore Than or Eq."}
        endcase
        Center( maxrow(), "Select an OPERATOR by pressing the LETTER or"+ ;
          " by Cursor Movement & Return")
        nOperator  := VertMenu( aMenu, 09, 58, " OPERATOR ", "", TRUE)
        if nOperator == 0
          exit
        endif
        *SayVerbiage( cCondition)
        //
        ClearFrom( maxrow())
        do case
          case aField[ a, FTYPE] == "C" .and. aField[ a, LENGTH] <= 15
            cMsg  := "Enter a Literal "
            @ maxrow(), 40- (len( cMsg)+ len(cClause))/ 2 say cMsg
            @ maxrow(), 41+ len( cMsg)/ 2 get xTemp picture cClause
            ARead()
            ClearFrom( maxrow())
            do case
              case nOperator  == 1
                cCondition  := cCondition+ cFieldName+ "="+  ["]+         ;
                  trim( xTemp)+ ["]
              case nOperator == 2
                cCondition  := cCondition+ cFieldName+ "<>"+ ["]+         ;
                  trim( xTemp)+ ["]
              case nOperator == 3
                cCondition  := cCondition+ cFieldName+ "<="+ ["]+         ;
                  trim( xTemp)+ ["]
              otherwise
                cCondition  := cCondition+ cFieldName+ ">="+ ["]+         ;
                  trim( xTemp)+ ["]
            endcase
          case aField[ a, FTYPE] == "C" .and. aField[ a, LENGTH] > 15     ;
            .or. aField[ a, FTYPE] == "M"
            @ maxrow(), 13 say "Enter a Literal" get xTemp picture cClause
            ARead()
            ClearFrom( maxrow())
            if nOperator == 1
              cCondition  := cCondition+ " at( "+ ["]+ trim( xTemp)+ ["]+ ;
                ", upper( "+ cFieldName+ "))<>0"
            else
              cCondition  := cCondition+ " at( "+ ["]+ trim( xTemp)+ ["]+ ;
                ", upper( "+ cFieldName+ "))=0"
            endif
          case aField[ a, FTYPE] == "D"
            @ maxrow(), 28 say "Enter a Date " get xTemp 
            ARead()
            xTemp = dtoc( xTemp)
            ClearFrom( maxrow())
            if nOperator == 1
              cCondition  := cCondition+ cFieldName+ " <= "+              ;
                "CTOD("+ ["]+ xTemp+ ["]+ ")"
            else
              if nOperator == 2
                cCondition  := cCondition+ cFieldName+ " = "+             ;
                  "CTOD("+ ["]+ xTemp+ ["]+ ")"
              else
                cCondition  := cCondition+ cFieldName+ " >= "+            ;
                  "CTOD("+ ["]+ xTemp+ ["]+ ")"
              endif
            endif
          case aField[ a, FTYPE] == "N"
            @ maxrow(), 23 say "Enter a Numeric Value "                   ;
              get xTemp picture "9999999999"
            ARead()
            ClearFrom( maxrow())
            do case
              case nOperator == 1
                cCondition  := cCondition+ cFieldName+ " = "+             ;
                  ltrim( str( xTemp))
              case nOperator == 2
                cCondition  := cCondition+ cFieldName+ " <> "+            ;
                  ltrim( str( xTemp))
              case nOperator == 3
                cCondition  := cCondition+ cFieldName+ " <= "+            ;
                  ltrim( str( xTemp))
              case nOperator == 4
                cCondition  := cCondition+ cFieldName+ " >= "+            ;
                  ltrim( str( xTemp))
            endcase
          case aField[ a, FTYPE] == "L"
            xTemp  := FALSE
            cMsg   := cFieldName+ " = true or false "
            @ maxrow(), 40- len( cMsg)/ 2 say cMsg
            @ maxrow(), 41+ len( cMsg)/ 2 get xTemp
            ARead()
            if xTemp
              cCondition  := cCondition+ cFieldName
            else
              cCondition  := cCondition+ " ! "+ cFieldName
            endif
        endcase
        SayVerbiage( cCondition)
        //
        //
      case nChoice == 2                && left paren
        nLPCount    := nLPCount+ 1
        cCondition  := cCondition+ "("
        //
        //
      case nChoice == 1                && right paren
        if nLPCount == nRPCount
          tone( 4000, 1)
          ImmedError( maxrow(), "Unnecessary right parenthesis!")
          WAITKEY( 3)
          ClearFrom( maxrow())
          LOOP
        endif
        if nLPCount > 0
          ++nRPCount
          cCondition  := cCondition+ ")"
        else
          tone( 4000, 1)
          ImmedError( maxrow(), "There are no left parenthesis!")
          WAITKEY( 3)
          ClearFrom( maxrow())
        endif
        //
        //
      case nChoice == 4                && Connector
        aMenu  := {                                                       ;
          "^tA^nnd         ",                                             ;
          "^tO^nr          "}
        Center( maxrow(), "Select a Connector by pressing the LETTER or"+ ;
          " by Cursor Movement & Return")
        nConnector  := VertMenu( aMenu, 04, 58, " CONNECTOR ", "", TRUE)
        if nConnector == 0
          exit
        endif
        do case
          case nConnector == 1
            cCondition  := cCondition+ " .and. "
          case nConnector == 2
            cCondition  := cCondition+ " .or. "
        endcase
        SayVerbiage( cCondition)
        ClearFrom( maxrow())
        //
        //
      case nChoice == 5                && remove filter
        cCondition  := ""
        exit
        //
        //
      case nChoice == 6                && Done
        if nLPCount == nRPCount
          lDone  := TRUE
        else
          tone( 4000, 1)
          if nRPCount > nLPCount
            Center( maxrow(), "Left parenthesis added to correct unbala"+ ;
              "nced parenthesis.")
            WAITKEY( 3)
            do while nLPCount < nRPCount
              cCondition  := "("+ cCondition
              ++nLPCount
            enddo
          else
            Center( maxrow(), "Right parenthesis added to correct unbal"+ ;
              "anced parenthesis.")
            WAITKEY( 3)
            do while nRPCount < nLPCount
              cCondition  := cCondition+ ")"
              ++nRPCount
            enddo
          endif
          LOOP
        endif
        //
        //
      case nChoice == 7                && abandon filter
        exit
        //
        //
      case nChoice == 8                && start over
        nLastChoice  := 0
        nRPCount     := 0
        nLPCount     := 0
        cCondition   := ""
        //
        //
      case nChoice == 9                && view more
        Center( maxrow(), "Use cursor nKeys to move. Press 'Ctrl-W' or "+ ;
          "'Esc' when Done viewing")
        SETATTR( 17, 23, 20, 75, c_WinTxt, " ")
        memoedit( cCondition, 17, 23, 20, 75, FALSE)
        ClearFrom( maxrow())
    endcase
    SayVerbiage( cCondition)
  enddo
  ClearFrom( maxrow())
return cCondition
//
// end filter



function SayVerbiage( string_in)
  PRINT( 17, 23, memoline( string_in, 52, 1, 4, TRUE), c_WinTxt)
  PRINT( 18, 23, memoline( string_in, 52, 2, 4, TRUE), c_WinTxt)
  PRINT( 19, 23, memoline( string_in, 52, 3, 4, TRUE), c_WinTxt)
  PRINT( 20, 23, memoline( string_in, 52, 4, 4, TRUE), c_WinTxt)
return NIL
//
// end SayVerbiage



function FieldSelect()         && assumes DATA-> is selected
  local aItems  := {}
  local n       := 0
  local nBott   := iif( lastrec() > maxrow()- 5, maxrow()- 2, lastrec()+ 4)
  local sScreen := savescreen( 03, 01, nBott+ 2, 18)
  //
  Window( 03, 01, nBott, 16, " FIELDS ", "")
  for n := 1 to fcount()
    aadd( aItems, field( n))
  next
  //
  n = MX_CHOICE( 03, 01, nBott, 16, aItems, c_WinTxt)
  MOUSE OFF
  //
  restscreen( 03, 01, nBott+ 2, 18, sScreen)
return (n)
//
// end fieldselect



function ClearFrom( nRow)
  SETATTR( nRow, 00, maxrow(), 79, c_DeskTop, " ")
return NIL
//
// end cleafrom



function ARead()
  set cursor on
  read
  set cursor off
return NIL
//
// end AREAD



function Center( nLine, cMessage)
  if nLine >= 0 .and. nLine <= maxrow()
    SETATTR( nLine, 00, nLine, 79, c_DeskTop, " ")
    if len( cMessage) <= 80
      PRINT( nLine, 40- (len( cMessage)/ 2), cMessage, c_Message)
    else
      PRINT( nLine, 00, substr( cMessage, 1, 80), c_Message)
    endif
  endif
return NIL
//
// end center



function Window( nTop, nLeft, nBott, nRight, cTitle, cFooter)
  BOX( nTop, nLeft, nBott, nRight, "͸", c_WinBox)  && funcky
  SETATTR( nTop+ 1, nLeft+ 1, nBott- 1, nRight- 1, c_WinTxt, " ")  && funcky
  if ! empty( cTitle)
    PRINT( nTop, ((nLeft+ ((nRight- nLeft)/ 2))- len( cTitle)/ 2)+ 1,     ;
    cTitle, c_WinBox)
  endif
  if ! empty( cfooter)
    PRINT( nBott, ((nLeft+ ((nRight- nLeft)/ 2))- len( cFooter)/ 2)+ 1,   ;
    cFooter, c_WinBox)
  endif
return NIL
//
// end window



function ImmedError( nRow, cMessage)
  @ nRow, 00
  PRINT( nRow, 40- len( cErrMsg)/ 2, cErrMsg, c_ErrMsg)
  tone( 2000, 1)
return NIL
//
// end IMMEDERROR

//
// eof aquery.prg
